/*
  Copyright (c) 2006 XenSource, Inc.  All rights reserved.
*/

#define _GNU_SOURCE
#include <stdio.h>
#include <string.h>

#include "xen_vm.h"


static char *call_func(const char *data, size_t len, void *handle)
{
    fprintf(stderr, "Sending: %d %*s.\n", (int)len, (int)len, data);

    return strdup("<methodResponse><params><param><value><struct><member><name>Status</name><value>Success</value></member><member><name>Value</name><value>vm-id-1</value></member></struct></value></param></params></methodResponse>");
}


static void print_error(xen_session *session)
{
    fprintf(stderr, "Error: %d", session->error_description_count);
    for (int i = 0; i < session->error_description_count; i++)
    {
        fprintf(stderr, "%s ", session->error_description[i]);
    }
    fprintf(stderr, "\n");
}


int main(int argc, char **argv)
{
    xen_session *session =
        xen_session_login_with_password(call_func, NULL, "ewan", "letmein");

    xen_vm vm = xen_vm_get_by_uuid(session, "0000");
    char *uuid = xen_vm_get_uuid(session, vm);

    if (!session->ok)
    {
        print_error(session);
        xen_session_logout(session);
        return 1;
    }

    printf("%s.\n", uuid);

    xen_session_logout(session);
    return 0;
}
