/*
  Copyright (c) 2006 XenSource, Inc.  All rights reserved.
*/

#ifndef XEN_COMMON_H
#define XEN_COMMON_H


#include <stdbool.h>
#include <stddef.h>


/**
 * The caller will free the result.
 *
 * len does not include a terminating \0.
 */
typedef char *(*xen_call_func)(const char *, size_t len, void *);


typedef struct
{
    xen_call_func call_func;
    void *handle;
    const char *session_id;
    bool ok;
    char **error_description;
    int error_description_count;
} xen_session;


struct xen_task_;
typedef struct xen_task_ * xen_task_id;


typedef struct
{
    int progress;
    long eta;
    /* !!! RESULT */
}  xen_task_status;


extern xen_session *
xen_session_login_with_password(xen_call_func call_func, void *handle,
                                const char *uname, const char *pwd);


extern void
xen_session_logout(xen_session *session);


#endif
