/*
  Copyright (c) 2006 XenSource, Inc.  All rights reserved.
*/

#ifndef XEN_INTERNAL_H
#define XEN_INTERNAL_H


#include <stdbool.h>
#include <inttypes.h>

#include "xen_common.h"


enum abstract_typename
{
  VOID,
  STRING,
  INT,
  FLOAT,
  BOOL,
  SET,
  MAP,
  FAILURE,
  TASK
};


typedef struct abstract_type
{
  enum abstract_typename typename;
  struct abstract_type *child1;
  struct abstract_type *child2;
} abstract_type;


typedef struct abstract_value
{
  abstract_type type;
  union
  {
    const char *string_val;
    uint64_t int_val;
    double double_val;
    bool bool_val;
  } u;
} abstract_value;


extern void
xen_call_(xen_session *s, const char *method_name, abstract_value params[],
          int param_count, abstract_type result_type, void *value);


extern char *
xen_strdup_(char *in);


#endif
