/*
  Copyright (c) 2006 XenSource, Inc.  All rights reserved.
*/

#include "xen_internal.h"
#include "xen_vm.h"


xen_vm_set
xen_vm_get_all(xen_session *s)
{
    abstract_type member_type = { .typename = STRING };
    abstract_type result_type = { .typename = SET,
                                  .child1 = &member_type };
    
    xen_vm_set result;
    xen_call_(s, "Vm.get_all", NULL, 0, result_type, &result);
    return result;
}


xen_vm
xen_vm_get_by_uuid(xen_session *s, char *uuid)
{
    abstract_value params[] =
        {
            { .type.typename = STRING,
              .u.string_val = uuid }
        };
    abstract_type result_type = { .typename = STRING };
    
    char *result;
    xen_call_(s, "Vm.get_by_uuid", params, sizeof(params) / sizeof(params[0]),
              result_type, &result);
    return result;
}


char *
xen_vm_get_uuid(xen_session *s, xen_vm vm)
{
    return s->ok ? xen_strdup_((char *)vm) : NULL;
}
